diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/spectrum-propagation-loss-model.h ns-3.44/src/spectrum/model/spectrum-propagation-loss-model.h
--- ns-3.43/src/spectrum/model/spectrum-propagation-loss-model.h	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/spectrum-propagation-loss-model.h	2025-03-09 16:55:49.695372300 -0700
@@ -11,8 +11,8 @@
 
 #include "spectrum-value.h"
 
-#include <ns3/mobility-model.h>
-#include <ns3/object.h>
+#include "ns3/mobility-model.h"
+#include "ns3/object.h"
 
 namespace ns3
 {
@@ -20,9 +20,9 @@
 struct SpectrumSignalParameters;
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  *
- * \brief spectrum-aware propagation loss model
+ * @brief spectrum-aware propagation loss model
  *
  * Interface for propagation loss models to be adopted when
  * transmissions are modeled with a power spectral density by means of
@@ -36,8 +36,8 @@
     ~SpectrumPropagationLossModel() override;
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -77,8 +77,8 @@
      * together, this method will also assign streams to the
      * downstream models.
      *
-     * \param stream the stream index offset start
-     * \return the number of stream indices assigned by this model
+     * @param stream the stream index offset start
+     * @return the number of stream indices assigned by this model
      */
     int64_t AssignStreams(int64_t stream);
 
@@ -89,8 +89,8 @@
      *
      * Subclasses must implement this; those not using random variables can return zero.
      *
-     * \param stream first stream index to use
-     * \return the number of stream indices assigned by this model
+     * @param stream first stream index to use
+     * @return the number of stream indices assigned by this model
      */
     virtual int64_t DoAssignStreams(int64_t stream) = 0;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/spectrum-signal-parameters.cc ns-3.44/src/spectrum/model/spectrum-signal-parameters.cc
--- ns-3.43/src/spectrum/model/spectrum-signal-parameters.cc	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/spectrum-signal-parameters.cc	2025-03-09 16:55:49.695372300 -0700
@@ -11,8 +11,8 @@
 #include "spectrum-phy.h"
 #include "spectrum-value.h"
 
-#include <ns3/antenna-model.h>
-#include <ns3/log.h>
+#include "ns3/antenna-model.h"
+#include "ns3/log.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/spectrum-signal-parameters.h ns-3.44/src/spectrum/model/spectrum-signal-parameters.h
--- ns-3.43/src/spectrum/model/spectrum-signal-parameters.h	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/spectrum-signal-parameters.h	2025-03-09 16:55:49.695372300 -0700
@@ -9,8 +9,8 @@
 #ifndef SPECTRUM_SIGNAL_PARAMETERS_H
 #define SPECTRUM_SIGNAL_PARAMETERS_H
 
-#include <ns3/matrix-array.h>
-#include <ns3/nstime.h>
+#include "ns3/matrix-array.h"
+#include "ns3/nstime.h"
 
 namespace ns3
 {
@@ -20,7 +20,7 @@
 class AntennaModel;
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  *
  * This struct provides the generic signal representation to be used by
  * all wireless technologies. Any specific wireless technology is
@@ -35,7 +35,7 @@
  * directly from this struct, each PHY can test (by using a dynamic
  * cast) if a signal being received belongs to a given technology or not.
  *
- * \note when inheriting from this class, make sure that the assignment operator and the copy
+ * @note when inheriting from this class, make sure that the assignment operator and the copy
  * constructor work properly, making deep copies if needed.
  */
 struct SpectrumSignalParameters : public SimpleRefCount<SpectrumSignalParameters>
@@ -52,7 +52,7 @@
 
     /**
      * copy constructor
-     * \param p object to copy
+     * @param p object to copy
      */
     SpectrumSignalParameters(const SpectrumSignalParameters& p);
 
@@ -65,7 +65,7 @@
      * SpectrumSignalParameters should override this method and use it
      * to call the copy constructor of the derived class.
      *
-     * \return a copy of the (possibly derived) class
+     * @return a copy of the (possibly derived) class
      */
     virtual Ptr<SpectrumSignalParameters> Copy() const;
 
@@ -76,7 +76,7 @@
      * underwater acoustic communications. Other transmission media to
      * be defined.
      *
-     * \note when SpectrumSignalParameters is copied, only the pointer to the PSD will be copied.
+     * @note when SpectrumSignalParameters is copied, only the pointer to the PSD will be copied.
      * This is because SpectrumChannel objects normally overwrite the psd anyway, so there is no
      * point in making a copy.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/spectrum-transmit-filter.cc ns-3.44/src/spectrum/model/spectrum-transmit-filter.cc
--- ns-3.43/src/spectrum/model/spectrum-transmit-filter.cc	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/spectrum-transmit-filter.cc	2025-03-09 16:55:49.695372300 -0700
@@ -10,7 +10,7 @@
 #include "spectrum-phy.h"
 #include "spectrum-signal-parameters.h"
 
-#include <ns3/log.h>
+#include "ns3/log.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/spectrum-transmit-filter.h ns-3.44/src/spectrum/model/spectrum-transmit-filter.h
--- ns-3.43/src/spectrum/model/spectrum-transmit-filter.h	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/spectrum-transmit-filter.h	2025-03-09 16:55:49.695372300 -0700
@@ -7,7 +7,7 @@
 #ifndef SPECTRUM_TRANSMIT_FILTER_H
 #define SPECTRUM_TRANSMIT_FILTER_H
 
-#include <ns3/object.h>
+#include "ns3/object.h"
 
 namespace ns3
 {
@@ -16,9 +16,9 @@
 class SpectrumPhy;
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  *
- * \brief spectrum-aware transmit filter object
+ * @brief spectrum-aware transmit filter object
  *
  * Interface for transmit filters that permit an early discard of signal
  * reception before propagation loss models or receiving Phy objects have
@@ -31,8 +31,8 @@
     SpectrumTransmitFilter();
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -40,14 +40,14 @@
      * Add a transmit filter to be consulted next if this filter does not
      * filter the signal
      *
-     * \param next next transmit filter to add to the chain
+     * @param next next transmit filter to add to the chain
      */
     void SetNext(Ptr<SpectrumTransmitFilter> next);
 
     /**
      * Return the next transmit filter in the chain
      *
-     * \return next transmit filter in the chain
+     * @return next transmit filter in the chain
      */
     Ptr<const SpectrumTransmitFilter> GetNext() const;
 
@@ -56,10 +56,10 @@
      * instead be filtered (discarded) before being processed in this channel
      * and on the receiving Phy.
      *
-     * \param params the spectrum signal parameters.
-     * \param receiverPhy pointer to the receiving SpectrumPhy
+     * @param params the spectrum signal parameters.
+     * @param receiverPhy pointer to the receiving SpectrumPhy
      *
-     * \return whether to perform filtering of the signal
+     * @return whether to perform filtering of the signal
      */
     bool Filter(Ptr<const SpectrumSignalParameters> params, Ptr<const SpectrumPhy> receiverPhy);
 
@@ -71,8 +71,8 @@
      * together, this method will also assign streams to the
      * downstream models.
      *
-     * \param stream the stream index offset start
-     * \return the number of stream indices assigned by this model
+     * @param stream the stream index offset start
+     * @return the number of stream indices assigned by this model
      */
     int64_t AssignStreams(int64_t stream);
 
@@ -83,8 +83,8 @@
      *
      * Subclasses must implement this; those not using random variables can return zero.
      *
-     * \param stream first stream index to use
-     * \return the number of stream indices assigned by this model
+     * @param stream first stream index to use
+     * @return the number of stream indices assigned by this model
      */
     virtual int64_t DoAssignStreams(int64_t stream) = 0;
 
@@ -94,10 +94,10 @@
      * instead be filtered (discarded) before being processed in this channel
      * and on the receiving Phy.
      *
-     * \param params the spectrum signal parameters.
-     * \param receiverPhy pointer to the receiving SpectrumPhy
+     * @param params the spectrum signal parameters.
+     * @param receiverPhy pointer to the receiving SpectrumPhy
      *
-     * \return whether to perform filtering of the signal
+     * @return whether to perform filtering of the signal
      */
     virtual bool DoFilter(Ptr<const SpectrumSignalParameters> params,
                           Ptr<const SpectrumPhy> receiverPhy) = 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/spectrum-value.cc ns-3.44/src/spectrum/model/spectrum-value.cc
--- ns-3.43/src/spectrum/model/spectrum-value.cc	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/spectrum-value.cc	2025-03-09 16:55:49.695372300 -0700
@@ -9,8 +9,8 @@
 
 #include "spectrum-value.h"
 
-#include <ns3/log.h>
-#include <ns3/math.h>
+#include "ns3/log.h"
+#include "ns3/math.h"
 
 namespace ns3
 {
@@ -374,10 +374,10 @@
 }
 
 /**
- * \brief Output stream operator
- * \param os output stream
- * \param pvf the SpectrumValue to print
- * \return an output stream
+ * @brief Output stream operator
+ * @param os output stream
+ * @param pvf the SpectrumValue to print
+ * @return an output stream
  */
 std::ostream&
 operator<<(std::ostream& os, const SpectrumValue& pvf)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/spectrum-value.h ns-3.44/src/spectrum/model/spectrum-value.h
--- ns-3.43/src/spectrum/model/spectrum-value.h	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/spectrum-value.h	2025-03-09 16:55:49.695372300 -0700
@@ -11,8 +11,8 @@
 
 #include "spectrum-model.h"
 
-#include <ns3/ptr.h>
-#include <ns3/simple-ref-count.h>
+#include "ns3/ptr.h"
+#include "ns3/simple-ref-count.h"
 
 #include <ostream>
 #include <vector>
@@ -24,9 +24,9 @@
 typedef std::vector<double> Values;
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  *
- * \brief Set of values corresponding to a given SpectrumModel
+ * @brief Set of values corresponding to a given SpectrumModel
  *
  * This class implements a Function Space which can represent any
  * function \f$ g: F \in {\sf
@@ -143,14 +143,14 @@
     Values::iterator ValuesEnd();
 
     /**
-     * \brief Get the number of values stored in the array
-     * \return the values array size
+     * @brief Get the number of values stored in the array
+     * @return the values array size
      */
     uint32_t GetValuesN() const;
 
     /**
      * Directly set the values using the std::vector<double>
-     * \param values a reference to the std::vector<double>
+     * @param values a reference to the std::vector<double>
      */
     inline void SetValues(Values& values)
     {
@@ -162,7 +162,7 @@
 
     /**
      * Directly set the values by moving the values from the input std::vector<double>
-     * \param values a reference to the std::vector<double> to be moved
+     * @param values a reference to the std::vector<double> to be moved
      */
     inline void SetValues(Values&& values)
     {
@@ -173,9 +173,9 @@
     }
 
     /**
-     * \brief Provides the direct access to the underlying std::vector<double>
+     * @brief Provides the direct access to the underlying std::vector<double>
      * that stores the spectrum values.
-     * \return a reference to the stored values
+     * @return a reference to the stored values
      */
     inline Values& GetValues()
     {
@@ -183,9 +183,9 @@
     }
 
     /**
-     * \brief Provides the direct read-only access to the underlying std::vector<double>
+     * @brief Provides the direct read-only access to the underlying std::vector<double>
      * that stores the spectrum values.
-     * \return a const reference to the stored values
+     * @return a const reference to the stored values
      */
     inline const Values& GetValues() const
     {
@@ -193,9 +193,9 @@
     }
 
     /**
-     * \brief Get the value element at the position
-     * \param pos position
-     * \return the value element in that position (with bounds checking)
+     * @brief Get the value element at the position
+     * @param pos position
+     * @return the value element in that position (with bounds checking)
      */
     const double& ValuesAt(uint32_t pos) const;
 
@@ -553,8 +553,8 @@
     /**
      *  TracedCallback signature for SpectrumValue.
      *
-     * \param [in] value Value of the traced variable.
-     * \deprecated The non-const \c Ptr<SpectrumPhy> argument
+     * @param [in] value Value of the traced variable.
+     * @deprecated The non-const \c Ptr<SpectrumPhy> argument
      * is deprecated and will be changed to \c Ptr<const SpectrumPhy>
      * in a future release.
      */
@@ -564,42 +564,42 @@
   private:
     /**
      * Add a SpectrumValue (element to element addition)
-     * \param x SpectrumValue
+     * @param x SpectrumValue
      */
     void Add(const SpectrumValue& x);
     /**
      * Add a flat value to all the current elements
-     * \param s flat value
+     * @param s flat value
      */
     void Add(double s);
     /**
      * Subtracts a SpectrumValue (element by element subtraction)
-     * \param x SpectrumValue
+     * @param x SpectrumValue
      */
     void Subtract(const SpectrumValue& x);
     /**
      * Subtracts a flat value to all the current elements
-     * \param s flat value
+     * @param s flat value
      */
     void Subtract(double s);
     /**
      * Multiplies for a SpectrumValue (element to element multiplication)
-     * \param x SpectrumValue
+     * @param x SpectrumValue
      */
     void Multiply(const SpectrumValue& x);
     /**
      * Multiplies for a flat value to all the current elements
-     * \param s flat value
+     * @param s flat value
      */
     void Multiply(double s);
     /**
      * Divides by a SpectrumValue (element to element division)
-     * \param x SpectrumValue
+     * @param x SpectrumValue
      */
     void Divide(const SpectrumValue& x);
     /**
      * Divides by a flat value to all the current elements
-     * \param s flat value
+     * @param s flat value
      */
     void Divide(double s);
     /**
@@ -608,25 +608,25 @@
     void ChangeSign();
     /**
      * Shift the values to the left
-     * \param n number of positions to shift
+     * @param n number of positions to shift
      */
     void ShiftLeft(int n);
     /**
      * Shift the values to the right
-     * \param n number of positions to shift
+     * @param n number of positions to shift
      */
     void ShiftRight(int n);
     /**
      * Modifies each element so that it each element is raised to the exponent
      *
-     * \param exp the exponent
+     * @param exp the exponent
      */
     void Pow(double exp);
     /**
      * Modifies each element so that it is
      * the base raised to each element value
      *
-     * \param base the base
+     * @param base the base
      */
     void Exp(double base);
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/three-gpp-channel-model.cc ns-3.44/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.43/src/spectrum/model/three-gpp-channel-model.cc	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/three-gpp-channel-model.cc	2025-03-09 16:55:49.695372300 -0700
@@ -18,8 +18,9 @@
 #include "ns3/node.h"
 #include "ns3/phased-array-model.h"
 #include "ns3/pointer.h"
+#include "ns3/shuffle.h"
+#include "ns3/simulator.h"
 #include "ns3/string.h"
-#include <ns3/simulator.h>
 
 #include <algorithm>
 #include <array>
@@ -713,48 +714,48 @@
  * the quantized elevation angle.
  * The inner vector collects the table3gpp values.
  */
-static const std::map<std::string, std::map<int, std::array<float, 20>>> NTNDenseUrbanNLOS{
+static const std::map<std::string, std::map<int, std::array<float, 22>>> NTNDenseUrbanNLOS{
     {"S",
      {
-         {10, {-6.84, 0.82, -2.08, 0.87, 1.0,  1.6, 1.0, 0.63, -2.08, 0.58,
-               2.3,   23.8, 4.4,   4.0,  20.0, 3.9, 0.0, 15.0, 7.0,   3.0}},
-         {20, {-6.81, 0.61, -1.68, 0.73, 1.44, 0.87, 0.94, 0.65, -1.66, 0.5,
-               2.3,   21.9, 6.3,   4.0,  20.0, 3.9,  0.0,  15.0, 7.0,   3.0}},
-         {30, {-6.94, 0.49, -1.46, 0.53, 1.54, 0.64, 1.15, 0.42, -1.48, 0.4,
-               2.3,   19.7, 8.1,   4.0,  20.0, 3.9,  0.0,  15.0, 7.0,   3.0}},
-         {40, {-7.14, 0.49, -1.43, 0.5, 1.53, 0.56, 1.35, 0.28, -1.46, 0.37,
-               2.3,   18.1, 9.3,   4.0, 20.0, 3.9,  0.0,  15.0, 7.0,   3.0}},
-         {50, {-7.34, 0.51, -1.44, 0.58, 1.48, 0.54, 1.44, 0.25, -1.53, 0.47,
-               2.3,   16.3, 11.5,  4.0,  20.0, 3.9,  0.0,  15.0, 7.0,   3.0}},
-         {60, {-7.53, 0.47, -1.33, 0.49, 1.39, 0.68, 1.56, 0.16, -1.61, 0.43,
-               2.3,   14.0, 13.3,  4.0,  20.0, 3.9,  0.0,  15.0, 7.0,   3.0}},
-         {70, {-7.67, 0.44, -1.31, 0.65, 1.42, 0.55, 1.64, 0.18, -1.77, 0.5,
-               2.3,   12.1, 14.9,  4.0,  20.0, 3.9,  0.0,  15.0, 7.0,   3.0}},
-         {80, {-7.82, 0.42, -1.11, 0.69, 1.38, 0.6, 1.7, 0.09, -1.9, 0.42,
-               2.3,   8.7,  17.0,  4.0,  20.0, 3.9, 0.0, 15.0, 7.0,  3.0}},
-         {90, {-7.84, 0.55, -0.11, 0.53, 1.23, 0.6, 1.7, 0.17, -1.99, 0.5,
-               2.3,   6.4,  12.3,  4.0,  20.0, 3.9, 0.0, 15.0, 7.0,   3.0}},
+         {10, {-6.84, 0.82, -2.08, 0.87, 1.0, 1.6,  1.0, 0.63, -2.08, 0.58, 0.0,
+               0.0,   2.3,  23.8,  4.4,  4.0, 20.0, 3.9, 0.0,  15.0,  7.0,  3.0}},
+         {20, {-6.81, 0.61, -1.68, 0.73, 1.44, 0.87, 0.94, 0.65, -1.66, 0.5, 0.0,
+               0.0,   2.3,  21.9,  6.3,  4.0,  20.0, 3.9,  0.0,  15.0,  7.0, 3.0}},
+         {30, {-6.94, 0.49, -1.46, 0.53, 1.54, 0.64, 1.15, 0.42, -1.48, 0.4, 0.0,
+               0.0,   2.3,  19.7,  8.1,  4.0,  20.0, 3.9,  0.0,  15.0,  7.0, 3.0}},
+         {40, {-7.14, 0.49, -1.43, 0.5, 1.53, 0.56, 1.35, 0.28, -1.46, 0.37, 0.0,
+               0.0,   2.3,  18.1,  9.3, 4.0,  20.0, 3.9,  0.0,  15.0,  7.0,  3.0}},
+         {50, {-7.34, 0.51, -1.44, 0.58, 1.48, 0.54, 1.44, 0.25, -1.53, 0.47, 0.0,
+               0.0,   2.3,  16.3,  11.5, 4.0,  20.0, 3.9,  0.0,  15.0,  7.0,  3.0}},
+         {60, {-7.53, 0.47, -1.33, 0.49, 1.39, 0.68, 1.56, 0.16, -1.61, 0.43, 0.0,
+               0.0,   2.3,  14.0,  13.3, 4.0,  20.0, 3.9,  0.0,  15.0,  7.0,  3.0}},
+         {70, {-7.67, 0.44, -1.31, 0.65, 1.42, 0.55, 1.64, 0.18, -1.77, 0.5, 0.0,
+               0.0,   2.3,  12.1,  14.9, 4.0,  20.0, 3.9,  0.0,  15.0,  7.0, 3.0}},
+         {80, {-7.82, 0.42, -1.11, 0.69, 1.38, 0.6,  1.7, 0.09, -1.9, 0.42, 0.0,
+               0.0,   2.3,  8.7,   17.0, 4.0,  20.0, 3.9, 0.0,  15.0, 7.0,  3.0}},
+         {90, {-7.84, 0.55, -0.11, 0.53, 1.23, 0.6,  1.7, 0.17, -1.99, 0.5, 0.0,
+               0.0,   2.3,  6.4,   12.3, 4.0,  20.0, 3.9, 0.0,  15.0,  7.0, 3.0}},
      }},
     {"Ka",
      {
-         {10, {-6.86, 0.81, -2.12, 0.94, 1.02, 1.44, 1.01, 0.56, -2.11, 0.59,
-               2.3,   23.7, 4.5,   4.0,  20.0, 3.9,  0.0,  15.0, 7.0,   3.0}},
-         {20, {-6.84, 0.61, -1.74, 0.79, 1.44, 0.77, 0.96, 0.55, -1.69, 0.51,
-               2.3,   21.8, 6.3,   4.0,  20.0, 3.9,  0.0,  15.0, 7.0,   3.0}},
-         {30, {-7.0, 0.56, -1.56, 0.66, 1.48, 0.7, 1.13, 0.43, -1.52, 0.46,
-               2.3,  19.6, 8.2,   4.0,  20.0, 3.9, 0.0,  15.0, 7.0,   3.0}},
-         {40, {-7.21, 0.56, -1.54, 0.63, 1.46, 0.6, 1.3, 0.37, -1.51, 0.43,
-               2.3,   18.0, 9.4,   4.0,  20.0, 3.9, 0.0, 15.0, 7.0,   3.0}},
-         {50, {-7.42, 0.57, -1.45, 0.56, 1.4,  0.59, 1.4, 0.32, -1.54, 0.45,
-               2.3,   16.3, 11.5,  4.0,  20.0, 3.9,  0.0, 15.0, 7.0,   3.0}},
-         {60, {-7.86, 0.55, -1.64, 0.78, 0.97, 1.27, 1.41, 0.45, -1.84, 0.63,
-               2.3,   15.9, 12.4,  4.0,  20.0, 3.9,  0.0,  15.0, 7.0,   3.0}},
-         {70, {-7.76, 0.47, -1.37, 0.56, 1.33, 0.56, 1.63, 0.17, -1.86, 0.51,
-               2.3,   12.3, 15.0,  4.0,  20.0, 3.9,  0.0,  15.0, 7.0,   3.0}},
-         {80, {-8.07, 0.42, -1.29, 0.76, 1.12, 1.04, 1.68, 0.14, -2.16, 0.74,
-               2.3,   10.5, 15.7,  4.0,  20.0, 3.9,  0.0,  15.0, 7.0,   3.0}},
-         {90, {-7.95, 0.59, -0.41, 0.59, 1.04, 0.63, 1.7, 0.17, -2.21, 0.61,
-               2.3,   10.5, 15.7,  4.0,  20.0, 3.9,  0.0, 15.0, 7.0,   3.0}},
+         {10, {-6.86, 0.81, -2.12, 0.94, 1.02, 1.44, 1.01, 0.56, -2.11, 0.59, 0.0,
+               0.0,   2.3,  23.7,  4.5,  4.0,  20.0, 3.9,  0.0,  15.0,  7.0,  3.0}},
+         {20, {-6.84, 0.61, -1.74, 0.79, 1.44, 0.77, 0.96, 0.55, -1.69, 0.51, 0.0,
+               0.0,   2.3,  21.8,  6.3,  4.0,  20.0, 3.9,  0.0,  15.0,  7.0,  3.0}},
+         {30, {-7.0, 0.56, -1.56, 0.66, 1.48, 0.7,  1.13, 0.43, -1.52, 0.46, 0.0,
+               0.0,  2.3,  19.6,  8.2,  4.0,  20.0, 3.9,  0.0,  15.0,  7.0,  3.0}},
+         {40, {-7.21, 0.56, -1.54, 0.63, 1.46, 0.6,  1.3, 0.37, -1.51, 0.43, 0.0,
+               0.0,   2.3,  18.0,  9.4,  4.0,  20.0, 3.9, 0.0,  15.0,  7.0,  3.0}},
+         {50, {-7.42, 0.57, -1.45, 0.56, 1.4, 0.59, 1.4, 0.32, -1.54, 0.45, 0.0,
+               0.0,   2.3,  16.3,  11.5, 4.0, 20.0, 3.9, 0.0,  15.0,  7.0,  3.0}},
+         {60, {-7.86, 0.55, -1.64, 0.78, 0.97, 1.27, 1.41, 0.45, -1.84, 0.63, 0.0,
+               0.0,   2.3,  15.9,  12.4, 4.0,  20.0, 3.9,  0.0,  15.0,  7.0,  3.0}},
+         {70, {-7.76, 0.47, -1.37, 0.56, 1.33, 0.56, 1.63, 0.17, -1.86, 0.51, 0.0,
+               0.0,   2.3,  12.3,  15.0, 4.0,  20.0, 3.9,  0.0,  15.0,  7.0,  3.0}},
+         {80, {-8.07, 0.42, -1.29, 0.76, 1.12, 1.04, 1.68, 0.14, -2.16, 0.74, 0.0,
+               0.0,   2.3,  10.5,  15.7, 4.0,  20.0, 3.9,  0.0,  15.0,  7.0,  3.0}},
+         {90, {-7.95, 0.59, -0.41, 0.59, 1.04, 0.63, 1.7, 0.17, -2.21, 0.61, 0.0,
+               0.0,   2.3,  10.5,  15.7, 4.0,  20.0, 3.9, 0.0,  15.0,  7.0,  3.0}},
      }},
 };
 
@@ -1670,7 +1671,7 @@
             table3gpp->m_uLgZSD = -0.1 * log10(1 + fcGHz) + 0.73;
             table3gpp->m_sigLgZSD = -0.04 * log10(1 + fcGHz) + 0.34;
             table3gpp->m_offsetZOD = 0;
-            table3gpp->m_cDS = 5;
+            table3gpp->m_cDS = 5 * 1e-9;
             table3gpp->m_cASD = 17;
             table3gpp->m_cASA = 17;
             table3gpp->m_cZSA = 7;
@@ -1704,7 +1705,7 @@
             table3gpp->m_uLgZSD = -0.04 * log10(1 + fcGHz) + 0.92;
             table3gpp->m_sigLgZSD = -0.07 * log10(1 + fcGHz) + 0.41;
             table3gpp->m_offsetZOD = 0;
-            table3gpp->m_cDS = 11;
+            table3gpp->m_cDS = 11 * 1e-9;
             table3gpp->m_cASD = 22;
             table3gpp->m_cASA = 22;
             table3gpp->m_cZSA = 7;
@@ -1738,7 +1739,7 @@
             table3gpp->m_uLgZSD = -0.04 * log10(1 + fcGHz) + 0.92;
             table3gpp->m_sigLgZSD = -0.07 * log10(1 + fcGHz) + 0.41;
             table3gpp->m_offsetZOD = 0;
-            table3gpp->m_cDS = 11;
+            table3gpp->m_cDS = 11 * 1e-9;
             table3gpp->m_cASD = 22;
             table3gpp->m_cASA = 22;
             table3gpp->m_cZSA = 7;
@@ -1779,7 +1780,7 @@
             table3gpp->m_uLgZSD = -0.1 * log10(1 + fcGHz) + 0.73;
             table3gpp->m_sigLgZSD = -0.04 * log10(1 + fcGHz) + 0.34;
             table3gpp->m_offsetZOD = 0;
-            table3gpp->m_cDS = 5;
+            table3gpp->m_cDS = 5 * 1e-9;
             table3gpp->m_cASD = 17;
             table3gpp->m_cASA = 17;
             table3gpp->m_cZSA = 7;
@@ -1813,7 +1814,7 @@
             table3gpp->m_uLgZSD = -0.04 * log10(1 + fcGHz) + 0.92;
             table3gpp->m_sigLgZSD = -0.07 * log10(1 + fcGHz) + 0.41;
             table3gpp->m_offsetZOD = 0;
-            table3gpp->m_cDS = 11;
+            table3gpp->m_cDS = 11 * 1e-9;
             table3gpp->m_cASD = 22;
             table3gpp->m_cASA = 22;
             table3gpp->m_cZSA = 7;
@@ -1851,7 +1852,7 @@
             table3gpp->m_uLgZSD = -0.04 * log10(1 + fcGHz) + 0.92;
             table3gpp->m_sigLgZSD = -0.07 * log10(1 + fcGHz) + 0.41;
             table3gpp->m_offsetZOD = 0;
-            table3gpp->m_cDS = 11;
+            table3gpp->m_cDS = 11 * 1e-9;
             table3gpp->m_cASD = 22;
             table3gpp->m_cASA = 22;
             table3gpp->m_cZSA = 7;
@@ -1971,7 +1972,8 @@
                 table3gpp->m_raysPerCluster = NTNDenseUrbanLOS.at(freqBand).at(
                     elevAngleQuantized)[Table3gppParams::raysPerCluster];
                 table3gpp->m_cDS =
-                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS] *
+                    1e-9;
                 table3gpp->m_cASD =
                     NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
                 table3gpp->m_cASA =
@@ -2023,7 +2025,8 @@
                 table3gpp->m_raysPerCluster = NTNDenseUrbanNLOS.at(freqBand).at(
                     elevAngleQuantized)[Table3gppParams::raysPerCluster];
                 table3gpp->m_cDS =
-                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS] *
+                    1e-9;
                 table3gpp->m_cASD =
                     NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
                 table3gpp->m_cASA =
@@ -2081,7 +2084,7 @@
                 table3gpp->m_raysPerCluster = NTNUrbanLOS.at(freqBand).at(
                     elevAngleQuantized)[Table3gppParams::raysPerCluster];
                 table3gpp->m_cDS =
-                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS] * 1e-9;
                 table3gpp->m_cASD =
                     NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
                 table3gpp->m_cASA =
@@ -2136,7 +2139,7 @@
                 table3gpp->m_raysPerCluster = NTNUrbanNLOS.at(freqBand).at(
                     elevAngleQuantized)[Table3gppParams::raysPerCluster];
                 table3gpp->m_cDS =
-                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS] * 1e-9;
                 table3gpp->m_cASD =
                     NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
                 table3gpp->m_cASA =
@@ -2195,7 +2198,7 @@
                 table3gpp->m_raysPerCluster = NTNSuburbanLOS.at(freqBand).at(
                     elevAngleQuantized)[Table3gppParams::raysPerCluster];
                 table3gpp->m_cDS =
-                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS] * 1e-9;
                 table3gpp->m_cASD =
                     NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
                 table3gpp->m_cASA =
@@ -2250,7 +2253,8 @@
                 table3gpp->m_raysPerCluster = NTNSuburbanNLOS.at(freqBand).at(
                     elevAngleQuantized)[Table3gppParams::raysPerCluster];
                 table3gpp->m_cDS =
-                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS] *
+                    1e-9;
                 table3gpp->m_cASD =
                     NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
                 table3gpp->m_cASA =
@@ -2308,7 +2312,7 @@
                 table3gpp->m_raysPerCluster = NTNRuralLOS.at(freqBand).at(
                     elevAngleQuantized)[Table3gppParams::raysPerCluster];
                 table3gpp->m_cDS =
-                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS] * 1e-9;
                 table3gpp->m_cASD =
                     NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
                 table3gpp->m_cASA =
@@ -2363,7 +2367,7 @@
                 table3gpp->m_raysPerCluster = NTNRuralNLOS.at(freqBand).at(
                     elevAngleQuantized)[Table3gppParams::raysPerCluster];
                 table3gpp->m_cDS =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS] * 1e-9;
                 table3gpp->m_cASD =
                     NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
                 table3gpp->m_cASA =
@@ -2460,8 +2464,9 @@
     size_t uAntNumElems = bAntenna->GetNumElems();
     size_t chanNumRows = channelMatrix->m_channel.GetNumRows();
     size_t chanNumCols = channelMatrix->m_channel.GetNumCols();
-    return ((uAntNumElems != chanNumRows) || (sAntNumElems != chanNumCols)) &&
-           ((uAntNumElems != chanNumCols) || (sAntNumElems != chanNumRows));
+    return (((uAntNumElems != chanNumRows) || (sAntNumElems != chanNumCols)) &&
+            ((uAntNumElems != chanNumCols) || (sAntNumElems != chanNumRows))) ||
+           aAntenna->IsChannelOutOfDate(bAntenna);
 }
 
 Ptr<const MatrixBasedChannelModel::ChannelMatrix>
@@ -3036,10 +3041,10 @@
 
     for (uint8_t cIndex = 0; cIndex < channelParams->m_reducedClusterNumber; cIndex++)
     {
-        Shuffle(&rayAodRadian[cIndex][0], &rayAodRadian[cIndex][table3gpp->m_raysPerCluster]);
-        Shuffle(&rayAoaRadian[cIndex][0], &rayAoaRadian[cIndex][table3gpp->m_raysPerCluster]);
-        Shuffle(&rayZodRadian[cIndex][0], &rayZodRadian[cIndex][table3gpp->m_raysPerCluster]);
-        Shuffle(&rayZoaRadian[cIndex][0], &rayZoaRadian[cIndex][table3gpp->m_raysPerCluster]);
+        Shuffle(rayAodRadian[cIndex].begin(), rayAodRadian[cIndex].end(), m_uniformRvShuffle);
+        Shuffle(rayAoaRadian[cIndex].begin(), rayAoaRadian[cIndex].end(), m_uniformRvShuffle);
+        Shuffle(rayZodRadian[cIndex].begin(), rayZodRadian[cIndex].end(), m_uniformRvShuffle);
+        Shuffle(rayZoaRadian[cIndex].begin(), rayZoaRadian[cIndex].end(), m_uniformRvShuffle);
     }
 
     // store values
@@ -3865,15 +3870,6 @@
     return powerAttenuation;
 }
 
-void
-ThreeGppChannelModel::Shuffle(double* first, double* last) const
-{
-    for (auto i = (last - first) - 1; i > 0; --i)
-    {
-        std::swap(first[i], first[m_uniformRvShuffle->GetInteger(0, i)]);
-    }
-}
-
 int64_t
 ThreeGppChannelModel::AssignStreams(int64_t stream)
 {
